//
//  BFRecordScreenViewModel.swift
//  Pods
//
//  Created by ak on 2021/12/7.
//

import BFCommonKit
import BFMediaKit
import BFNetRequestKit
import Foundation
import ObjectMapper
import RealmSwift

public class BFRecordScreenViewModel: NSObject {
    /// 取文本转语言 token
    /// - Parameter completeHander: <#completeHander description#>
    public class func getNlsAccessToken(completeHander: @escaping (_ token: String, _ appkey: String) -> Void) {
        let NlsAccessTokenKey: String = "NlsAccessTokenKey_JiangjieApp"

        let nowTime: TimeInterval = Date().timeIntervalSince1970

        //        token = "5d96258dcea34d7b91576031cd25a9ba"; 返回数据
        //        expireTime = 1601376826000; //1601377050000;
        let saveToken: Dictionary? = getUserDefaults(key: NlsAccessTokenKey) as? [String: Any] ?? nil
        if saveToken != nil && Double(saveToken!["expireTime"] as! Double) > nowTime * 1000 {
            BFLog(message: "nls token 还有效期内不用重新请求 \(String(describing: saveToken!["expireTime"])) nowTime:\(nowTime * 1000)")
            completeHander(saveToken!["token"] as! String, saveToken!["appkey"] as! String)
            return
        }
        BFNetRequestAdaptor.getRequestData(url: PQENVUtil.shared.clipapiapi + getNlsAccessTokenForJiangjieApp, parames: nil, commonParams: commonParams()) { response, _, _, _ in

            if let response = response as? [String: Any], let token = response["token"] as? String, let appkey = response["appkey"] as? String {
                let nowTime: TimeInterval = Date().timeIntervalSince1970

                BFLog(message: "nowTime is \(nowTime) token is \(token)")
                saveUserDefaults(key: NlsAccessTokenKey, value: response)

                completeHander(token, appkey)
            } else {
                completeHander("", "")
            }
        }
    }

    /// 分段识别录音
    /// - Parameters:
    ///   - sectionIndex: 段落id
    ///   - locationPaths: 分段录音
    ///   - completeHander: <#completeHander description#>
    /// - Returns: description
    public class func batchUploadRecordVoiceMatarialData(beginTime _: CMTime, locationPath: String, completeHander _: @escaping (_ subTitleList: List<PQEditVisionTrackMaterialsModel>?, _ msg: String?) -> Void) {
        BFLog(message: "录音文件开始上传--\(locationPath)")

        if !FileManager.default.fileExists(atPath: documensDirectory + locationPath) {
            BFLog(message: "上传录音-录音文件不存在")
        } else {
            let assert = AVURLAsset(url: URL(fileURLWithPath: documensDirectory + locationPath), options: nil)
            let voiceMaterials: PQEditVisionTrackMaterialsModel = PQEditVisionTrackMaterialsModel()
            voiceMaterials.locationPath = locationPath
            voiceMaterials.type = "voice"
            voiceMaterials.duration = assert.duration.seconds * 1_000_000
            BFLog(message: "上传录音-开始上传录音")
//            PQVideoEditViewModel.uploadMatarialData(isBatchUpload: false, materialData: voiceMaterials) { _, _, _, _, _, _, matarialInfo, _ in
//                let materialType: String = "\(matarialInfo?["materialType"] ?? "")"
//                let localPath: String = "\(matarialInfo?["localPath"] ?? "")"
//
//                BFLog(message: "上传录音-录音上传返回--\(String(describing: matarialInfo))")
//                if matarialInfo != nil, matarialInfo?.keys.contains("localPath") ?? false, materialType == StickerType.VOICE.rawValue && localPath.contains("_noise_") {
//                    BFLog(message: "上传录音-录音上传成功开始转化字幕")
//                    let materialId: String = "\(matarialInfo?["materialId"] ?? "")"
//                    let duration: Float64 = Float64("\(matarialInfo?["duration"] ?? "")") ?? 0
//                    PQVideoEditViewModel.transferAudioMaterialToTextData(Int64(materialId) ?? 0, dutation: duration) { _, _, subTitleList, _ in
//                        BFLog(message: "上传录音-字幕转化完成:\(subTitleList.count)")
//
//                        if subTitleList.count > 0 {
//
//                        }
//
//                    }
//                }
//            }
        }

        //        dispatchGroup.notify(queue: DispatchQueue.main) {
        //            BFLog(message: "语音均已识别完成")
        //            let subTitleList: List<PQEditVisionTrackMaterialsModel> = List<PQEditVisionTrackMaterialsModel>.init()
        //            BFLog(message: "tempSubTitles == \(String(describing: tempSubTitles.first))")
        //            tempSubTitles.forEach { tempItems in
        //                tempItems.forEach { item in
        //                    subTitleList.append(item)
        //                }
        //            }
        //            completeHander(sectionIndex, subTitleList, nil)
        //        }
    }
}
